float4x4 worldViewProj; float postfx;
//  Moved to HLSL and 3d-Overlay for Intro Maniac by Epyx
// Attention, dont load a Background Picture to see a effect 
// May lock the Mouse Position (extra/setup menu), to fix the star direction


uniform float time;
uniform float2 mouse;
uniform float2 resolution = float2(800,600) ; // Screensize;
float4 clear = float4(0.0f, 0.0f, 0.0f, 0.0f);


texture texture0;

sampler postTex = sampler_state
{  texture = (texture0);    };



float4 main(float2 gl_FragCoord: TEXCOORD0, float4 gl_FragColor: COLOR ) : COLOR
{

float4 color4  = tex2D(postTex ,   float2( gl_FragCoord.x,  gl_FragCoord.y  )); // original sichern



gl_FragCoord.y = 1 - gl_FragCoord.y; gl_FragCoord = gl_FragCoord * resolution;
float scale = abs(sin(0.0 * time) * 2.5 - 5.0);
float2 position = (((gl_FragCoord.xy / resolution) - 0.2) * scale) + scale * 0.75 * (mouse - 0.5);
float3 color = float3(0.0, 0.0, 0.0);      // Hintergrund Farbe


float fade = 0.0; 
float z      = 10.0;

float2 centered_coord = position - float2(0.5, 0.5);

for (float i=1.0; i<=128.0; i++)  {
float2 star_pos = float2(sin(i) * 150.0, sin(i*i*i) * 200.0);
float z = fmod(i*i - 32.0*time, 256.0);
float fade = (256.0 +z) / (10.0-(z*0.7));
float2 blob_coord = star_pos / z;
float gradient = ((fade / 4096.0) / pow(length(centered_coord - blob_coord), 1.5)) * (fade * fade);
color += float3(gradient * fmod(i, 61.0)/61.0, gradient * fmod(i, 27.0)/27.0, gradient * fmod(i, -17.0)/7.0);  }



//  if (color4.a  == clear.a )  {  gl_FragColor.a = color.a;  } else { gl_FragColor.a = color4.a; }
if (color4.r   == clear.r  )  {  gl_FragColor.r  = color.r;    } else { gl_FragColor.r = color4.r; }
if (color4.g  == clear.g )  {  gl_FragColor.g = color.g;  } else { gl_FragColor.g = color4.g; }
if (color4.b  == clear.b )  {  gl_FragColor.b = color.b;  } else { gl_FragColor.b = color4.b; }

return gl_FragColor;
}


// Vertex Shader
struct VS_INPUT
{
float3 position	: POSITION;
float2 texture0     : TEXCOORD0;
};

struct VS_OUTPUT
{
float4 hposition : POSITION;
float2 texture0  : TEXCOORD0;
};

VS_OUTPUT myvs( VS_INPUT IN )
{
VS_OUTPUT OUT;
if (postfx == 0) {
OUT.hposition = mul( worldViewProj, float4(IN.position.x ,IN.position.y ,IN.position.z, 1) );
} else {
OUT.hposition = float4(IN.position.x ,IN.position.y ,IN.position.z, 1);
}
OUT.texture0 = IN.texture0;
return OUT;
}
// ---------------------------------------------
technique Start
{
pass p1
{
VertexShader = compile vs_3_0 myvs();
PixelShader = compile ps_3_0 main();
}
}
