float4x4 worldViewProjI; float postfx;
// The Flaming Onion Ring!
// Not nearly as hot as what las posted on http://glsl.heroku.com/e#1802.0
// http://www.pouet.net/topic.php?which=7920&page=29&x=14&y=9


uniform float time;
uniform float2 mouse;
uniform float2 resolution = float2(933,511) ; // Screensize;

#define pi 3.14159265
#define R(p, a) p=cos(a)*p+sin(a)*float2(p.y, -p.x)
#define hsv(h,s,v) lerp(float3(1,1,1), clamp((abs(frac(h+float3(3., 2., 1.)/3.)*6.-3.)-1.), 0., 1.), s)*v

float pn(float3 p) {
float3 i = floor(p);
float4 a = dot(i, float3(1., 57., 21.)) + float4(0., 57., 21., 78.);
float3 f = cos((p-i)*pi)*(-.5) + .5;
a = lerp(sin(cos(a)*a), sin(cos(1.+a)*(1.+a)), f.x);
a.xy = lerp(a.xz, a.yw, f.y);
return lerp(a.x, a.y, f.z);
}
float fpn(float3 p) {
return pn(p*.06125)*.5 + pn(p*.125)*.25 + pn(p*.25)*.125;
}
float flamingOnionRing(float3 p) {
float2 q = float2(length(p.xy)-2.0,p.z);
return length(q)-1.0+sin(time);
}
float f(float3 p) {
p.z += 6.;
R(p.yz, -mouse.y*pi*2.);
R(p.xz, mouse.x*pi*2.);
return flamingOnionRing(p) + fpn(p*50.+time*25.) * 0.45;
}
float3 g(float3 p) {
float2 e = float2(.0001, .0);
return normalize(float3(f(p+e.xyy) - f(p-e.xyy),f(p+e.yxy) - f(p-e.yxy),f(p+e.yyx) - f(p-e.yyx)));
}
float4 main(float2 gl_FragCoord: TEXCOORD0, float4 gl_FragColor: COLOR ) : COLOR
{ 
if (postfx == 1) gl_FragCoord.x = gl_FragCoord.x + 0.23;
gl_FragCoord.y = 1 - gl_FragCoord.y; gl_FragCoord = gl_FragCoord * resolution;
// p: position on the ray

// d: direction of the ray
float3 p = float3(0.,0.,2.);
float3 d = float3((gl_FragCoord.xy/(0.5*resolution)-1.)*float2(resolution.x/resolution.y,1.0), 0.) - p;
d = normalize(d); 

// ld, td: local, total density 
// w: weighting factor
float ld, td= 0.;
float w;

// total color
float3 tc = float3(0,0,0);

// i: 0 <= i <= 1.
// r: length of the ray
// l: distance function

float i, r, l, b=0.;

// rm loop
for (float ii=0.; (ii<1.); ii+=1./64.) {
if(!((ii<1.) && (l>=0.001*r) && (r < 50.)&& (td < .95)))
break;

// evaluate distance function
l = f(p) * 0.5;
// check whether we are close enough
if (l < .05) {
// compute local density and weighting factor 
ld = 0.05 - l;
w = (1. - td) * ld; 
// accumulate color and density
tc += w * hsv(w, 1.0, 1.0); 
td += w;  }


td += 1./200.;

// enforce minimum stepsize
l = max(l, 0.03);

// step forward
p += l*d;
r += l;
} 

gl_FragColor = float4(tc, 1.0);
return gl_FragColor;
}

// Vertex Shader
struct VS_INPUT
{
float3 position : POSITION;
float2 texture0 : TEXCOORD0;
};
struct VS_OUTPUT
{
float4 hposition : POSITION;
float2 texture0 : TEXCOORD0;
};
VS_OUTPUT myvs( VS_INPUT IN )
{
VS_OUTPUT OUT;
if (postfx == 0) {
OUT.hposition = mul( worldViewProjI, float4(IN.position.x ,IN.position.y ,IN.position.z, 1) ); 
} else {
OUT.hposition = float4(IN.position.x ,IN.position.y ,IN.position.z, 1);
} 
OUT.texture0 = IN.texture0;
return OUT;
}


// ---------------------------------------------
technique Start
{
pass p1 
{
VertexShader = compile vs_3_0 myvs();
PixelShader = compile ps_3_0 main();
}
}
