float4x4 worldViewProjI; float postfx;

//Edit @ToBSn
// Edited by Anoki -changed some params
 
uniform float time;
uniform float2 mouse;
uniform float2 resolution = float2(1,1);

float getValue(float2 p, float x2, float y2, float t)
{
  float x=p.x;
  float y=p.y;
  float theta=dot(x2, y2);
  float2 d = float2(cos(theta), sin(theta)) + float2(x, y);
  d *= float2(y, y) * cos(p.y * t * 0.1) + dot(x,y);
  return length(d+theta);
}

float4 main(float2 gl_FragCoord: TEXCOORD0, float4 gl_FragColor: COLOR ) : COLOR {

	float2 position = ( gl_FragCoord.xy / resolution.xy ) * 2.0 - float2(1.0,resolution.y/resolution.x);
  	position *= 10.0;
  
  	float t = time + 10.0;

  	float a = 0.0;
  	a += getValue(position, tan(t)*.1, cos(t)*.2, t);
    	a *= getValue(position, sin(t)*.1, cos(t)*.2, t);
  	a += getValue(position, tan(t)*.1, cos(t)*.2, t);
  	a /= getValue(position, sin(t)*.1, cos(t)*.2, t);
  	a = 1./a;
  
  	float b = 5.0;
  	b += getValue(position, cos(t)*.1, sin(t)*.2, t);
    	b *= getValue(position, cos(t)*.1, sin(t)*.2, t);
  //	b += getValue(position, cos(t)*.1, sin(t)*.2, t);
  	b /= getValue(position, cos(t)*.1, sin(t)*.2, t);
  	b = 1./b;
  
  	float c = 0.0;
  	c += getValue(position, sin(t)*.1, cos(t)*.2, t);
    	c *= getValue(position, sin(t)*.1, cos(t)*.2, t);
  	c += getValue(position, sin(t)*.1, cos(t)*.2, t);
  	c /= getValue(position, sin(t)*.1, cos(t)*.2, t);
  	c = 1./c;
  
	gl_FragColor = float4( a, b, c, 1.0 );
            return gl_FragColor;

}

// Vertex Shader
struct VS_INPUT
{
    float3 position	: POSITION;
    float2 texture0     : TEXCOORD0;
};

struct VS_OUTPUT
{
     float4 hposition : POSITION;
     float2 texture0  : TEXCOORD0;
};

VS_OUTPUT myvs( VS_INPUT IN )
{
    VS_OUTPUT OUT;
    if (postfx == 0) {
      OUT.hposition = mul( worldViewProjI, float4(IN.position.x ,IN.position.y ,IN.position.z, 1) ); 
    } else {
      OUT.hposition = float4(IN.position.x ,IN.position.y ,IN.position.z, 1);
    }    
    OUT.texture0 = IN.texture0;
    return OUT;
}
// ---------------------------------------------
technique Start
{
    pass p1  
    {
        VertexShader = compile vs_3_0 myvs();
        PixelShader = compile ps_3_0 main();
    }
}
