// Plane deformations
// by Anton Platonov <platosha@gmail.com>
// twitter.com/platosha

float4x4 worldViewProjI;
uniform float time;
uniform float2 mouse;
uniform float2 resolution = float2(633,411) ; // Screensize;

float TAU = 5.2832;

float4 main(float2 gl_FragCoord: TEXCOORD0, float4 gl_FragColor: COLOR ) : COLOR {
gl_FragCoord.y = 1 - gl_FragCoord.y; gl_FragCoord = gl_FragCoord * resolution;


	float2 position = ( gl_FragCoord.xy / resolution.xy );
	float2 p = -1.0 + 2.0 * position;
	p *= float2( resolution.x/resolution.y, 1.0 );
	
	float alpha = -time * 0.13;
	float sinA = sin(alpha), cosA = cos(alpha);
	p = float2(cosA*p.x+sinA*p.y, -sinA*p.x+cosA*p.y);
	
	float2 q = p;
	float2 dir = float2( sin(time*0.19), cos(time*0.27) ) * 0.333;
	q = p + dir/pow(0.5, 1.0-dot(p-dir,p-dir));
	
	q = lerp(q, p, sin(time*0.78));
	
	float zr = 1.0/length(q);
	float zp = 1.0/abs(q.y);
	float mc = sin(time*0.16)*.5 + .5;
	mc = smoothstep(0.0, 1.0, mc);
	mc = smoothstep(0.0, 1.0, mc);
	mc = smoothstep(0.0, 1.0, mc);
	mc = smoothstep(0.0, 1.0, mc);
	float z = lerp(zr, zp, mc);
	float ur = 5.0*atan2(q.x*sign(q.y), abs(q.y))/TAU + cos(0.2*z*TAU+time*1.37) * 1.2 * sin( time * 0.21 );
	float up = q.x*z;
	float u = lerp(ur, up, mc);
	float2 uv = float2(u, (1.0+mc*2.0)*z);
	
	float mv = sin(time * 0.55);
	uv = lerp(uv, q, 0.0);
	
	float color = 0.0;
	color = cos(uv.x*TAU) * cos(uv.y*TAU + time*7.7);
	color = pow(abs(cos(color*TAU)), 3.0);
	
	float color2 = 0.0;
	color2 = cos(uv.x*TAU*2.0);
	color2 -= 0.25;
		
	float shadow = 1.0/(z*z);
	float3 rc = float3(0.9, 1.0, 0.8)*color +
		  float3(0.3, 0.7, 0.6)*color2;
	rc *= shadow;
	
	gl_FragColor = float4( rc, 1.0 );
            return gl_FragColor;


}

// Vertex Shader
struct VS_INPUT
{   float3 position	: POSITION;
    float2 texture0     : TEXCOORD0;  };

struct VS_OUTPUT
{    float4 hposition : POSITION;
     float2 texture0  : TEXCOORD0;  };


VS_OUTPUT myvs( VS_INPUT IN )
{   VS_OUTPUT OUT;
    OUT.hposition = float4(IN.position.x ,IN.position.y ,IN.position.z, 1);
    OUT.texture0 = IN.texture0;
    return OUT;  }

// ---------------------------------------------
technique Start
{  pass p1  
 
   {    VertexShader = compile vs_3_0 myvs();
        PixelShader = compile ps_3_0 main();
    }
}

