float4x4 worldViewProjI; float postfx;
// By @paulofalcao
// More blobs modifications :)

#ifdef GL_ES
// precision mediump float;
#endif

uniform float time;
uniform float2 mouse;
uniform float2 resolution = float2(800,600) ; // Screensize;


//.h      
float3 sim(float3 p,float s);
float2 rot(float2 p,float r);
float2 rotsim(float2 p,float s);
float2 zoom(float2 p,float f);

//nice stuff :)
float2 makeSymmetry(float2 p){
   float2 ret=p;
   ret=rotsim(ret,sin(time*0.3)*2.0+3.0);
   ret.x=abs(ret.x);
   return ret;
}

float makePoint(float x,float y,float fx,float fy,float sx,float sy,float t){
   float xx=x+tan(t*fx)*sy;
   float yy=y-tan(t*fy)*sy;
   float a=0.5/sqrt(abs(abs(x*xx)+abs(yy*y)));
   float b=0.5/sqrt(abs(x*xx+yy*y));
   return a*b;
}



//util functions
  float PI=3.14159265;

float3 sim(float3 p,float s){
   float3 ret=p;
   ret=p+s/2.0;
   ret=frac(ret/s)*s-s/4.0;
   return ret;
}

float2 rot(float2 p,float r){
   float2 ret;
   ret.x=p.x*sin(r)*cos(r)-p.y*cos(r);
   ret.y=p.x*cos(r)+p.y*sin(r);
   return ret;
}

float2 rotsim(float2 p,float s){
   float2 ret=p;
   ret=rot(p,-PI/(s*2.0));
   ret=rot(p,floor(atan2(ret.x,ret.y)/PI*s)*(PI/s));
   return ret;
}

float2 zoom(float2 p,float f){
    return float2(p.x*f,p.y*f);
}
//Util stuff end


float4 main(float2 gl_FragCoord: TEXCOORD0, float4 gl_FragColor: COLOR ) : COLOR {
gl_FragCoord.y = 1 - gl_FragCoord.y; gl_FragCoord = gl_FragCoord * resolution;

	
   float2 p = gl_FragCoord.xy/resolution.y-float2((resolution.x/resolution.y)/2.0,0.5);

   p=rot(p,sin(time+length(p))*4.0);
   p=zoom(p,sin(time*2.0)*0.5+0.8);

   p=p*2.0;
   
   float x=p.x;
   float y=p.y;
   
   float t=time*0.5;

   float a=
       makePoint(x,y,3.3,2.9,0.3,0.3,t);
   a=a+makePoint(x,y,1.9,2.0,0.4,0.4,t);
   a=a+makePoint(x,y,0.8,0.7,0.4,0.5,t);
   a=a+makePoint(x,y,2.3,0.1,0.6,0.3,t);
   a=a+makePoint(x,y,0.8,1.7,0.5,0.4,t);
   a=a+makePoint(x,y,0.3,1.0,0.4,0.4,t);
   a=a+makePoint(x,y,1.4,1.7,0.4,0.5,t);
   a=a+makePoint(x,y,1.3,2.1,0.6,0.3,t);
   a=a+makePoint(x,y,1.8,1.7,0.5,0.4,t);   
   
   float b=
       makePoint(x,y,1.2,1.9,0.3,0.3,t);
   b=b+makePoint(x,y,0.7,2.7,0.4,0.4,t);
   b=b+makePoint(x,y,1.4,0.6,0.4,0.5,t);
   b=b+makePoint(x,y,2.6,0.4,0.6,0.3,t);
   b=b+makePoint(x,y,0.7,1.4,0.5,0.4,t);
   b=b+makePoint(x,y,0.7,1.7,0.4,0.4,t);
   b=b+makePoint(x,y,0.8,0.5,0.4,0.5,t);
   b=b+makePoint(x,y,1.4,0.9,0.6,0.3,t);
   b=b+makePoint(x,y,0.7,1.3,0.5,0.4,t);

   float c=
       makePoint(x,y,3.7,0.3,0.3,0.3,t);
   c=c+makePoint(x,y,1.9,1.3,0.4,0.4,t);
   c=c+makePoint(x,y,0.8,0.9,0.4,0.5,t);
   c=c+makePoint(x,y,1.2,1.7,0.6,0.3,t);
   c=c+makePoint(x,y,0.3,0.6,0.5,0.4,t);
   c=c+makePoint(x,y,0.3,0.3,0.4,0.4,t);
   c=c+makePoint(x,y,1.4,0.8,0.4,0.5,t);
   c=c+makePoint(x,y,0.2,0.6,0.6,0.3,t);
   c=c+makePoint(x,y,1.3,0.5,0.5,0.4,t);
   
   float3 d=float3(a,b,c)/31.0;
   
   gl_FragColor = float4(d.x,d.y,d.z,1.0);
            return gl_FragColor;

}
	
// Vertex Shader
struct VS_INPUT
{
    float3 position	: POSITION;
    float2 texture0     : TEXCOORD0;
};

struct VS_OUTPUT
{
     float4 hposition : POSITION;
     float2 texture0  : TEXCOORD0;
};

VS_OUTPUT myvs( VS_INPUT IN )
{
    VS_OUTPUT OUT;
    if (postfx == 0) {
      OUT.hposition = mul( worldViewProjI, float4(IN.position.x ,IN.position.y ,IN.position.z, 1) ); 
    } else {
      OUT.hposition = float4(IN.position.x ,IN.position.y ,IN.position.z, 1);
    }    
    OUT.texture0 = IN.texture0;
    return OUT;
}
// ---------------------------------------------
technique Start
{
    pass p1  
    {
        VertexShader = compile vs_3_0 myvs();
        PixelShader = compile ps_3_0 main();
    }
}

