float4x4 worldViewProjI; float postfx;
#ifdef GL_ES
// precision mediump float;
#endif

#define PI 3.14159265

uniform float time;
//uniform float2 mouse;
uniform float2 resolution = float2(1,1);

float f(float x) {
	return (sin(x * 2.0 * PI ) + 1.0) / 2.0;
}

float q(float2 p) {
	float s = (f(p.x + 0.25)) / 5.0; 
	
	float c = smoothstep(0.9, 1.0, 1.0 - abs(p.y - s));  
	return c; 
}

float3 aurora(float2 p, float time) {
	float3 c1 = q( float2(p.y, p.x / 0.4) + float2(sin(time), -0.5)) * float3(15.0, 1.0, .9); 	
	float3 c2 = q( float2(p.y, p.x) + float2(time, -0.2)) * float3(.1, .1, .8); 	
	float3 c3 = q( float2(p.y, p.x / 0.2) + float2(time / 1.0, -.6)) * float3(.90, 1.0, .90); 
	
	return c1+c2+c3; 
}

float4 main(float2 gl_FragCoord: TEXCOORD0, float4 gl_FragColor: COLOR ) : COLOR {
	float2 p = ( gl_FragCoord.xy / resolution.xy );		
	float3 c = aurora(p, time); 
	gl_FragColor = float4(c, 1.0); 	
            return gl_FragColor;

}
// Vertex Shader
struct VS_INPUT
{
    float3 position	: POSITION;
    float2 texture0     : TEXCOORD0;
};

struct VS_OUTPUT
{
     float4 hposition : POSITION;
     float2 texture0  : TEXCOORD0;
};

VS_OUTPUT myvs( VS_INPUT IN )
{
    VS_OUTPUT OUT;
    if (postfx == 0) {
      OUT.hposition = mul( worldViewProjI, float4(IN.position.x ,IN.position.y ,IN.position.z, 1) ); 
    } else {
      OUT.hposition = float4(IN.position.x ,IN.position.y ,IN.position.z, 1);
    }    
    OUT.texture0 = IN.texture0;
    return OUT;
}
// ---------------------------------------------
technique Start
{
    pass p1  
    {
        VertexShader = compile vs_3_0 myvs();
        PixelShader = compile ps_3_0 main();
    }
}


