float4x4 worldViewProjI; float postfx;
// precision mediump float;

uniform float time;
uniform float2 mouse;
uniform float2 resolution = float2(1,1);

const float PI = 3.14159;

float4 main(float2 gl_FragCoord: TEXCOORD0, float4 gl_FragColor: COLOR ) : COLOR {
	
	float2 position = ( gl_FragCoord.xy / resolution.xy );

	float x = position.x * 0.2 + cos(position.y * -0.13);
	float t = time * 1.5;
	float3 color = float3(0.0,

		pow(
		 sin(t+x * 43.0) *
		 sin(t*-1.17+x * 179.0) *
		 sin(t*1.33+x * 229.0) *
		 sin(t*-0.91+x * 677.0)
		 , 1.0) * 0.5 + 0.5, 		

		pow(
		 sin(t-x * 53.0) *
		 sin(t*1.23+x * 167.0) *
		 sin(t*-1.41+x * 271.0) *
		 sin(t*0.77+x * 751.0)
		, 1.0) * 0.5 + 0.5);

	color = lerp(color, float3(1.0,1.0,1.0), 
			pow(
			 sin(t-x * 53.0) *
			 sin(t*1.23+x * 131.0) *
			 sin(t*-1.41+x * 313.0) *
			 sin(t*0.77+x * 673.0)
			, 2.0) / 1.0 * 1.0 + 0.5);

        color = lerp(float3(0.3,0.8,0.9), color, 0.3);

        color *= 1.2 - pow(sin(position.x + time * 0.1), 40.0) * 0.8;
        color *= sin((cos((position.x + time * 0.01) * 5.0) * 0.1  + position.y - 0.2) * PI) * 0.6 + 0.4;

	gl_FragColor = float4(color, 1.0 );
            return gl_FragColor;


}
// Vertex Shader
struct VS_INPUT
{
    float3 position	: POSITION;
    float2 texture0     : TEXCOORD0;
};

struct VS_OUTPUT
{
     float4 hposition : POSITION;
     float2 texture0  : TEXCOORD0;
};

VS_OUTPUT myvs( VS_INPUT IN )
{
    VS_OUTPUT OUT;
    if (postfx == 0) {
      OUT.hposition = mul( worldViewProjI, float4(IN.position.x ,IN.position.y ,IN.position.z, 1) ); 
    } else {
      OUT.hposition = float4(IN.position.x ,IN.position.y ,IN.position.z, 1);
    }    
    OUT.texture0 = IN.texture0;
    return OUT;
}
// ---------------------------------------------
technique Start
{
    pass p1  
    {
        VertexShader = compile vs_3_0 myvs();
        PixelShader = compile ps_3_0 main();
    }
}


