float4x4 worldViewProjI; float postfx;


#ifdef GL_ES
// precision mediump float;
#endif

uniform float time;
uniform float2 mouse;
uniform float2 resolution = float2(933,511) ; // Screensize;

float4 main(float2 gl_FragCoord: TEXCOORD0, float4 gl_FragColor: COLOR ) : COLOR {
gl_FragCoord.y = 1 - gl_FragCoord.y; gl_FragCoord = gl_FragCoord * resolution;


	float white;
    float4 color;
    float2 plasmaloc;
	float2 location = ( gl_FragCoord.xy / resolution.xy ) + mouse / 4.0;
    plasmaloc.x = location.x + cos(time * 0.1)*10.0;
    plasmaloc.y = location.y + sin(time * 0.1) * 7.0;
    plasmaloc /= 5.0;

    //Jonkinlainen plasmaefektilasku
    white = sin(plasmaloc.x) * sin(plasmaloc.y) * 2.5
          + sin(plasmaloc.x*(2.0 + 5.0*cos(plasmaloc.y*5.0))) * 1.5
          + sin(plasmaloc.y*(3.0 + 7.0*cos(plasmaloc.x*3.0))) * 1.5;

    white = abs(sin(white));

    //Mritelln fragmentin lopullinen vri
    color.x = (1.0 - white) * abs(sin(plasmaloc.y));
    color.y = white;
    color.z = 0.5 - 0.5 * white + 0.5;
    color.w = 1.0;

    //Kerrotaan viel OpenGL:lle vri...

    gl_FragColor  = color;
            return gl_FragColor;

}
// Vertex Shader
struct VS_INPUT
{
    float3 position	: POSITION;
    float2 texture0     : TEXCOORD0;
};

struct VS_OUTPUT
{
     float4 hposition : POSITION;
     float2 texture0  : TEXCOORD0;
};

VS_OUTPUT myvs( VS_INPUT IN )
{
    VS_OUTPUT OUT;
    if (postfx == 0) {
      OUT.hposition = mul( worldViewProjI, float4(IN.position.x ,IN.position.y ,IN.position.z, 1) ); 
    } else {
      OUT.hposition = float4(IN.position.x ,IN.position.y ,IN.position.z, 1);
    }    
    OUT.texture0 = IN.texture0;
    return OUT;
}
// ---------------------------------------------
technique Start
{
    pass p1  
    {
        VertexShader = compile vs_3_0 myvs();
        PixelShader = compile ps_3_0 main();
    }
}
