float4x4 worldViewProjI; float postfx;
#ifdef GL_ES
// precision highp float;
#endif
//tweaks, anony_gt
uniform float time;
uniform float2 mouse;
uniform float2 resolution = float2(1,1);

uniform sampler2D backbuffer;

float orbitDistance = 0.00025;
float waveLength = 200.100;

float4 main(float2 gl_FragCoord: TEXCOORD0, float4 gl_FragColor: COLOR ) : COLOR {
	float2 uv = gl_FragCoord.xy/resolution;

	float2 p1 = (float2(sin(time), cos(time))*orbitDistance)-.5;
	float2 p2 = (float2(sin(time+3.142), cos(time+3.142))*orbitDistance)+1.75;

	float d1 = 0.1-length(uv +p1);
	float d2 = 0.1-length(uv -p2);

	float wave1 = sin(d1/waveLength+(time*1.))*0.5 + 0.5 * (((d1 - 0.75) * 2.) + 2.5);
	float wave2 = sin(d2*waveLength+(time*5.))*0.5 + 0.5 * (((d1 - 0.25) * 2.) + .5);
	float c = d1 > 0.99 || d2 > 0.995 ? 1. : 0.;
	c + wave1*wave2;
	gl_FragColor = float4(c + wave1*wave2,c,c,1.);

	// "bumpmapping" @Flexi23
	float2 d = 1./resolution;
	float dx = tex2D(backbuffer, uv + float2(-1.,0.)*d).x - tex2D(backbuffer, uv + float2(1.,0.)*d).x ;
	float dy = tex2D(backbuffer, uv + float2(0.,-1.)*d).x - tex2D(backbuffer, uv + float2(0.,1.)*d).x ;
	d = float2(dx,dy)*resolution/resolution.x*2.;
	gl_FragColor.z = pow(clamp(1.-1.5*length(uv  - float2(.7*cos(time*.5)+.5,1.*sin(time*.5)+.5) + d),0.,1.),4.0);
	gl_FragColor.y = gl_FragColor.z*.5 + gl_FragColor.x*0.25;

	gl_FragColor *=10.25;
            return gl_FragColor;


}



// Vertex Shader
struct VS_INPUT
{
    float3 position	: POSITION;
    float2 texture0     : TEXCOORD0;
};

struct VS_OUTPUT
{
     float4 hposition : POSITION;
     float2 texture0  : TEXCOORD0;
};

VS_OUTPUT myvs( VS_INPUT IN )
{
    VS_OUTPUT OUT;
    if (postfx == 0) {
      OUT.hposition = mul( worldViewProjI, float4(IN.position.x ,IN.position.y ,IN.position.z, 1) ); 
    } else {
      OUT.hposition = float4(IN.position.x ,IN.position.y ,IN.position.z, 1);
    }    
    OUT.texture0 = IN.texture0;
    return OUT;
}
// ---------------------------------------------
technique Start
{
    pass p1  
    {
        VertexShader = compile vs_3_0 myvs();
        PixelShader = compile ps_3_0 main();
    }
}
